import asyncio

from discord.utils import find

from jarvis.db.types import Setting


class GuildEventHandler(object):
    def __init__(self, bot):
        self.bot = bot
        self.bot.add_listener(self.on_guild_join)

    async def on_guild_join(self, guild):
        general = find(lambda x: x.name == "general", guild.channels)
        if general and general.permissions_for(guild.me).send_messages:
            user = self.bot.user
            await general.send(
                f"Allow me to introduce myself. I am {user.mention}, a virtual "
                + "artificial intelligence, and I'm here to assist you with a "
                + "variety of tasks as best I can, "
                + "24 hours a day, seven days a week."
            )
            await asyncio.sleep(1)
            await general.send(
                "Importing all preferences from home interface..."
            )

            # Set some default settings
            setting = Setting(guild=guild.id, setting="massmention", value=5)
            setting.insert()

            await general.send("Systems are now fully operational")
